function JsonParse(str_json) {
    return JSON.parse(str_json);
}

function setLocalImage(str_url, sprite, width, height) {
    var sprite_src = new cc.Sprite(str_url);
    sprite.updateWithSprite(sprite_src, cc.rect(0, 0, sprite_src.width, sprite_src.height), false, cc.p(0, 0), cc.size(width, height), cc.rect(0, 0, 0, 0));
}

function getImagePath(str_url) {
    if (cc.sys.os == cc.sys.OS_ANDROID) {
        return jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction", "getImgLocalPath", "(Ljava/lang/String;)Ljava/lang/String;", str_url);
    } else if (cc.sys.os == cc.sys.OS_IOS) {
        return null;
    }
}

function setWebImage(str_url, sprite) {
    var local_path = getImagePath(str_url);
    if (local_path == null || local_path.length <= 0) {
        cc.loader.loadImg(str_url, null, function (err, img) {
            if (err) {
                cc.log("error orrur!!!");
            } else {
                cc.log("load success!!!");
                sprite.setTexture(img);
            }
        });
    } else {
        // sprite.setTexture(local_path);
        cc.loader.loadImg(local_path, null, function (err, img) {
            if (err) {
                cc.log("error orrur!!!");
            } else {
                cc.log("load success!!!");
                sprite.setTexture(img);
            }
        });
    }
}

function loadWebImage(str_url, image) {
    cc.loader.loadImg(str_url, null, function (err, img) {
        if (err) {
            cc.log("error orrur!!!");
        } else {
            cc.log("load success!!!");
            image.loadTexture(img, "");
        }
    });
}

function openMarket(ad_item) {
    if (cc.sys.os == cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction", "OpenMarket", "(Ljava/lang/String;)V", ad_item.getArUrl());
    } else if (cc.sys.os == cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("NativeInteraction", "OpenMarket:", ad_item.getIOSUrl());
    }
}

function umengEvent(key, value) {
    var class_name = (cc.sys.os == cc.sys.OS_ANDROID) ? "com/duoduo/child/story/thirdparty/cocos/NativeInteraction" : "NativeInteraction";

    if (cc.sys.os == cc.sys.OS_ANDROID) {
        if (value) {
            jsb.reflection.callStaticMethod(class_name, "UmengEvent", "(Ljava/lang/String;Ljava/lang/String;)V", key, value);
        } else {
            jsb.reflection.callStaticMethod(class_name, "UmengEvent", "(Ljava/lang/String;)V", key);
        }

    } else if (cc.sys.os == cc.sys.OS_IOS) {
        if (value) {
            jsb.reflection.callStaticMethod(class_name, "UmengEvent::", key, value);
        } else {
            jsb.reflection.callStaticMethod(class_name, "UmengEvent:", key);
        }
    }
}

function winWidth() {
    if (isPad() || cc.sys.os != cc.sys.OS_ANDROID) {
        return 1334;
    }
    var strSize = jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction", "getScreenSize", "()Ljava/lang/String;");
    if (strSize && strSize.length) {
        var parse_result = JSON.parse(strSize);
        var width = parseInt(parse_result.width);
        var height = parseInt(parse_result.height);

        return width / height * 750;
    }

    return 1334;
}

function isFullScreenDevice() {
    return cc.sys.os == cc.sys.OS_ANDROID ? jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction", "isFullScreenDevice", "()Z") : false;
}

// function ddPlayEffect(method, url, loop) {
// 	var audioid = '';
//
// 	if (method == 'effect'){
// 		cc.audioEngine.playEffect(url, loop);
// 	}else if(method == 'music') {
// 		cc.audioEngine.playMusic(url, loop);
// 	} else {
// 		audioid = cc.audioEngine.playEffect(url, loop);
// 	}
//
// 	return audioid;
// }

// function ddStopEffect(method, audio) {
// 	if (cc.sys.os == cc.sys.OS_ANDROID || method == 'music') {
// 		cc.audioEngine.stopMusic();
// 	} else {
// 		if(audio){
// 			cc.audioEngine.stopEffect(audio);
// 		}
// 	}
// }

// function ddStopAllEffect() {
// 	cc.audioEngine.stopMusic();
// 	cc.audioEngine.stopAllEffects();
// }

function quiteGame() {
    if (cc.sys.os == cc.sys.OS_IOS) {
        cc.audioEngine.stopMusic();
        cc.audioEngine.stopAllEffects();
        JS_POP_GAME();
    } else {
        cc.director.end();
    }
}

function customRequire(file_name, define_status) {
    if (define_status == "undefined") {
        require(file_name);
    }
}

function releaseObj(obj) {
    if (obj) {
        obj.release();
        obj = null;
    }
}

function showAdBanner(isShow, xRation, yRation) {
    if (cc.sys.os == cc.sys.OS_ANDROID) {
        return jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction",
            "showADBanner", "(ZFF)V", isShow, xRation, yRation);
    }
}

function showLockView(target, callback) {
    if (vip_lock_status(dragon_play_index)) {
        console.log("vip status is defined!!!" + dragon_play_index);
        var lock_view = new LockViewLayer(callback);
        target.addChild(lock_view, Config_Home.lock_index);
        return lock_view;
    }

    console.log("vip status is undefined!!!" + dragon_play_index);

    return null;
}

function vip_lock_status(menu_index) {
    return false;
    // var android_enable = ((typeof(JS_GET_VIP) != "undefined") && (!JS_GET_VIP()));
    // 	var ios_enable = (typeof(JS_IS_VIP) != "undefined") && (!JS_IS_VIP());
    // 	return (android_enable || ios_enable) && vip_status[menu_index];
}

function releaseLockView(target) {
    if (target) {
        target.clearLockView();
    }
}

function openVip() {
    if (cc.sys.os == cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction", "BuyVip", "()V");
    } else {
        cc.audioEngine.stopMusic();
        cc.audioEngine.stopAllEffects();
        JS_OPEN_VIP();
    }
}

function playVideo() {
    if (cc.sys.os == cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction", "PlayVideo", "()V");
    } else if (cc.sys.os == cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("NativeInteraction", "PlayVideo");
    }
}

function getConfig(key) {
    if (cc.sys.os == cc.sys.OS_ANDROID) {
        return jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction",
            "readFile", "(Ljava/lang/String;)Ljava/lang/String;", key);
    }
}

function setConfig(key, value) {
    if (cc.sys.os == cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction",
            "saveToFile", "(Ljava/lang/String;Ljava/lang/String;)V", key, value);
    }
}

function showFeedback() {
    if (cc.sys.os == cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction",
            "startFeedbackActivity", "()V");
    }
}

function getAdId() {
    if (cc.sys.os == cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction",
            "getAdId", "()Ljava/lang/String;");
    }
}

function isPad() {
    if (cc.sys.os == cc.sys.OS_ANDROID) {
        return jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction", "isPad", "()Z");
    } else if (cc.sys.os == cc.sys.OS_IOS) {
        return false;
    }
}

function resetScale(sprite) {
    if (isPad()) {
        sprite.setScale(1.2, 1.2);
    }
}

function registerTouchEventOneByOne(target, isSwallow) {
    // cc.log("注册事件监听器");
    var obj = {
        event: cc.EventListener.TOUCH_ONE_BY_ONE,
        swallowTouches: isSwallow == null ? true : isSwallow,
        onTouchBegan: target.onTouchBegan.bind(target)
    };

    if (target.onTouchMoved) {
        obj.onTouchMoved = target.onTouchMoved.bind(target)
    }

    if (target.onTouchEnded) {
        obj.onTouchEnded = target.onTouchEnded.bind(target)
    }

    if (target.onTouchCanceled) {
        obj.onTouchCanceled = target.onTouchCanceled.bind(target)
    }
    var eventListener = cc.EventListener.create(obj);
    cc.eventManager.addListener(eventListener, target);
    return eventListener;
}

function openShortVideoActivity() {
    if (cc.sys.os == cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction",
            "startShortVideoActivity", "()V");
    }
}

function openApp(pkg) {
    if (cc.sys.os == cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction", "openApp", "(Ljava/lang/String;)V", pkg);
    }
}

function requestPermission() {

    if (cc.sys.os == cc.sys.OS_ANDROID) {
        return jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction",
            "requestPermission", "()V");
    } else {
        return false;
    }

}