var Global_DP_CoinLack = {
    dir: 'res/coin_lack/'
};
var DP_CoinLackLayer = cc.Layer.extend({
    ctor: function (number) {
        this._super();

        var self = this;
        var bgColor = zNewLayerColorCreate(this, cc.color(0, 0, 0, 125), cc.winSize);
        var bgColor_cb = zNewEventListenerCreate(null, null, function () {
            self.removeFromParent(true);
        }, null);
        zSetNodeEvent(bgColor_cb, bgColor);

        var dir = Global_DP_CoinLack.dir;
        var coin_bag_box = zNewSpriteCreate(dir, 'coin_bag_box', this);
        var coin_bag = zNewSpriteCreate(dir, 'coin_bag', coin_bag_box);
        var listener_coin_bag_box = zNewEventListenerCreate(null, null, null, null);
        coin_bag_box.setPosition(cc.winSize.width / 2, cc.winSize.height * 3 / 4 - 50);
        coin_bag.setPosition(coin_bag_box.width / 2, coin_bag_box.height / 2);
        zSetNodeEvent(listener_coin_bag_box, coin_bag_box);

        var label = zNewLabelCreate(number, null, 70, coin_bag);
        label.setPosition(206.59, 118.75);
        // zAddTouchLogPosEvent(label);

        var playName = ['fishing', 'shooting', 'whack_a_mole'];
        for (var i = 0; i < playName.length; ++i) {
            var play_box = zNewSpriteCreate(dir, 'play_box', this);
            var play = zNewSpriteCreate(dir, 'play_' + i + '_' + playName[i], play_box);
            var x = cc.winSize.width / 2 + (i - Math.floor(playName.length / 2)) * (play_box.width + 130);
            var y = cc.winSize.height / 4 + Math.abs(i * 2 - (playName.length - 1)) * play_box.height / 8;
            play_box.setPosition(x, y);
            play_box.setName(playName[i]);
            play.setPosition(play_box.width / 2, play_box.height / 2);
            play.runAction(cc.sequence(
                cc.delayTime(2 * i),
                cc.scaleTo(0.1, 1.1),
                cc.scaleTo(0.1, 0.9),
                cc.scaleTo(0.1, 1.1),
                cc.scaleTo(0.1, 0.9),
                cc.scaleTo(0.1, 1),
                cc.delayTime(6 - 2 * i)
            ).repeat(655350));
            zPauseTargetEvent(self, true);
            var listener = zNewEventListenerCreate(null, null, function (touch, target) {
                // zLog('play : ', target.getName());
                if (target.getName() == 'fishing') {
                    cc.director.pushScene(new DP_FishingScene());
                } else if (target.getName() == 'shooting') {
                    cc.director.pushScene(new DP_ShootingScene());
                } else if (target.getName() == 'whack_a_mole') {
                    cc.director.pushScene(new DP_WhackAMoleScene());
                }
                self.removeFromParent(true);
            }, null);
            zSetNodeEvent(listener, play_box);
        }

        var back_btn = zAddButtonEnded(this, Global_DP_Button.dir, 'back', function () {
            self.removeFromParent(true);
        });
        back_btn.setPosition(self.convertToNodeSpace(cc.p(back_btn.width / 2 + 20, cc.winSize.height - (back_btn.height / 2 + 20))));

        // var coin_lack = zNewSpineAnimationCreate(Global_DP_CoinLack.dir + 'spine/', 'skeleton', this);
        // coin_lack.setPosition(0, cc.winSize.height / 2);
        // coin_lack.setLocalZOrder(100);
        // coin_lack.setAnimation(0, 'sajinbi', true);
    },
    onEnter: function () {
        this._super();

        this.scheduleOnce(() => {
            ddSound.stopAll();
            ddSound.playEffect('coin_click_this_get_money_for_other_game');
        }, 2);
    },
    cleanup: function () {
        this._super();
        this.getParent().has_coin_lack_layer = false;
        this.getParent().scrollView.resumeEntry();
        this.getParent().showHomeBtn();
        // zLog('remove self');
    }
});

function zAddCoinLackLayer(parent, number) {
    if (parent.has_coin_lack_layer) {
        // zLog('already has_coin_lack_layer');
        return;
    }
    var layer = new DP_CoinLackLayer(number);
    parent.addChild(layer);
    parent.hideHomeBtn();
    parent.has_coin_lack_layer = true;
    layer.setPosition(parent.convertToNodeSpace(cc.p(0, 0)));
    return layer;
}

//
// 金币不够玩别的任何游戏 只能玩老虎机
var DP_CoinNoLayer = cc.LayerColor.extend({
    ctor: function () {
        this._super(cc.color(0, 0, 0, 125));

        var self = this;
        var event_node = new cc.Node();
        var listener = zNewEventListenerCreate(null, null, function () {
            self.removeFromParent(true);
        }, null);
        var coin_bag = zNewSpineAnimationCreate(Global_DP_CoinLack.dir + 'spine/', 'skeleton', this);
        coin_bag.setPosition(cc.winSize.width / 2, cc.winSize.height / 2);
        coin_bag.setAnimation(0, 'sajinbi', false);
        coin_bag.setCompleteListener((trackEntry) => {
            var name = trackEntry.animation ? trackEntry.animation.name : '';
            if (name == 'sajinbi') {
                // self.runAction(cc.removeSelf(true));
                coin_bag.runAction(cc.removeSelf(true));
                var slot_machine_box = zNewSpriteCreate(Global_DP_CoinLack.dir, 'slot_machine_box', self);
                var slot_machine = zNewSpriteCreate(Global_DP_CoinLack.dir, 'slot_machine', slot_machine_box);
                var touch_ended_cb = function (touch, target) {
                    zPauseTargetEvent(target);
                    self.removeFromParent(true);
                    cc.director.pushScene(new DP_SlotMachineScene());
                };
                var listener = zNewEventListenerCreate(null, null, touch_ended_cb, null);
                slot_machine_box.setPosition(cc.winSize.width / 2, cc.winSize.height / 2);
                slot_machine.setPosition(slot_machine_box.width / 2, slot_machine_box.height / 2);
                zSetNodeEvent(listener, slot_machine_box);
                slot_machine.runAction(cc.sequence(
                    cc.scaleTo(0.1, 1.1),
                    cc.scaleTo(0.1, 0.9),
                    cc.scaleTo(0.1, 1.1),
                    cc.scaleTo(0.1, 0.9),
                    cc.scaleTo(0.1, 1),
                    cc.delayTime(2)
                ).repeat(655350));
            }
        });
        ddSound.stopAll();
        ddSound.playEffect('coin_not_enough');
        event_node.setContentSize(cc.winSize.width, cc.winSize.height);
        this.addChild(event_node);
        this.setContentSize(cc.winSize);
        zSetNodeEvent(listener, event_node);
        zAddCoinBox(this);

        var back_btn = zAddButtonEnded(this, Global_DP_Button.dir, 'back', function () {
            self.removeFromParent(true);
        });
        back_btn.setPosition(self.convertToNodeSpace(cc.p(back_btn.width / 2 + 20, cc.winSize.height - (back_btn.height / 2 + 20))));
    },
    onEnter: function () {
        this._super();

        this.scheduleOnce(() => {

        }, 2);
    },
    cleanup: function () {
        this._super();
        this.getParent().has_coin_no_layer = false;
        this.getParent().scrollView.resumeEntry();
        this.getParent().showHomeBtn();
        // zLog('parent : ', this.getParent().getName());
    }
});

function zAddCoinNoLayer(parent) {
    if (parent.has_coin_no_layer) {
        // zLog('already has_coin_no_layer');
        return;
    }
    var layer = new DP_CoinNoLayer();
    parent.addChild(layer);
    parent.hideHomeBtn();
    parent.has_coin_no_layer = true;
    layer.setPosition(parent.convertToNodeSpace(cc.p(0, 0)));
}