var Global_DP_DiningRoom_ChooseInterface = {
    dir: 'res/game/dining_room/choose_interface/',
    btn_ok: null,
    tip_hand: null,
    layer: null
};

var DP_DiningRoomChooseInterfaceLayer = cc.Layer.extend({
    ctor: function () {
        this._super();
        Global_DP_DiningRoom_ChooseInterface.layer = this;
        var dir = Global_DP_DiningRoom.dir_choose_interface;
        var bg_hd = zNewSpriteCreate(dir, 'bg_hd', this);
        var table = zNewSpriteCreate(dir, 'table', this);
        var order_display = zNewSpriteCreate(dir, 'order_display', this);
        bg_hd.setAnchorPoint(0.5, 0);
        table.setPosition(0, 205.69 - (Global_DP.sinkY + 80));
        order_display.setPosition(100.07, 469.93 - (Global_DP.sinkY + 80));
        this.order_display = order_display;

        // zAddTouchLogPosEvent(order_display);
        // zAddTouchLogPosEvent(table);
        this.addOrder();
        this.addButtonOk();
        this.addTipHand();
    },
    onEnter: function () {
        this._super();

        this.scheduleOnce(() => {
            ddSound.stopAll();
            ddSound.playEffect('game_dinning_room_choose___combo');
        });

        // var row = Math.floor(Math.random() * 2) - 0.5;
        // var col = Math.floor(Math.random() * 3) - 1;
        var tip_hand = Global_DP_DiningRoom_ChooseInterface.tip_hand;
        var np = this.order_display.getPosition();
        var x = (Math.floor(Math.random() * 3) - 1) * 220;
        var y = (Math.floor(Math.random() * 2) - 0.5) * 200;
        tip_hand.autoTipAction(cc.pAdd(np, cc.p(x + 30, y)));
    },
    addOrder: function () {
        var dir = Global_DP_DiningRoom.dir_choose_interface;
        var orderName = ['food_hamburg', 'food_hot_dog', 'food_cake', 'drink_cola', 'drink_lemon', 'drink_ice_cream'];
        var order_display = this.order_display;
        var order = zAddRes(dir, orderName, this.order_display);
        var self = this;
        self.choose_food = null;
        self.choose_drink = null;
        self.bg_choose_food = zNewSpriteCreate(dir, 'bg_selected', order_display);
        self.bg_choose_food.setVisible(false);
        self.bg_choose_drink = zNewSpriteCreate(dir, 'bg_selected', order_display);
        self.bg_choose_drink.setVisible(false);
        self.btn_ok = null;
        self.playOtherSound = function () {
            // zLog(self.choose_drink, self.choose_food);
            if (!self.choose_drink) {
                ddSound.playEffect('game_dinning_room_choose__drink');
            } else if (!self.choose_food) {
                ddSound.playEffect('game_dinning_room_choose__food');
            }
        };
        for (var i = 0; i < orderName.length; ++i) {
            // zLog('row : ', Math.floor(i / 3), ', col : ', i % 3);
            // order[i].setPosition(pos[i]);
            order[i].setPosition(((i % 3) - 1) * 221 + order_display.width / 2 + 5, 420 - 190 * Math.floor(i / 3));
            order[i].setLocalZOrder(10);
            order[i].setName(orderName[i]);
            var touch_begin = function (touch, target) {
                ddSound.stopAll();
                ddSound.playEffect('game_dinning_decorate');
                ddSound.playEffect('game_dinning_room_' + target.getName());
                self.unschedule(self.playOtherSound);
                self.scheduleOnce(self.playOtherSound, 1);
                if (target.getName().indexOf('food') >= 0) {
                    // zLog('choose food : ', target.getName());
                    self.choose_food = target.getName();
                    self.bg_choose_food.setPosition(target.getPosition());
                    self.bg_choose_food.setVisible(true);
                    Global_DP_DiningRoom.make.food = target.getName();
                } else if (target.getName().indexOf('drink') >= 0) {
                    // zLog('choose drink : ', target.getName());
                    self.choose_drink = target.getName();
                    self.bg_choose_drink.setPosition(target.getPosition());
                    self.bg_choose_drink.setVisible(true);
                    Global_DP_DiningRoom.make.drink = target.getName();
                }
                if (self.choose_food && self.choose_drink) {
                    var btn_ok = Global_DP_DiningRoom_ChooseInterface.btn_ok;
                    btn_ok.into();
                }
                var tip_hand = Global_DP_DiningRoom_ChooseInterface.tip_hand;
                if (tip_hand != null) {
                    tip_hand.removeFromParent(true);
                    Global_DP_DiningRoom_ChooseInterface.tip_hand = null;
                }
            };
            var listener = zNewEventListenerCreate(touch_begin, null, null, null);
            zSetNodeEvent(listener, order[i]);
        }
    },
    addButtonOk: function () {
        var self = this;
        var btn_ok = zAddDiningRoomButtonOKLeft(self);
        // new DP_DiningRoom_ButtonOK();
        // var from = cc.p(-452.30, 151.09 - 200);
        // var to = cc.p(-452.30, 151.09);
        // btn_ok.setBaseImage(this, Global_DP_DiningRoom.dir, 'btn_ok', from);
        // btn_ok.setMovePos(from, to, 0.5);
        btn_ok.setEventCallBack(function () {
            self.removeFromParent(true);
            DP_DiningRoomMake();
        }, this);
        Global_DP_DiningRoom_ChooseInterface.btn_ok = btn_ok;
    },
    addTipHand: function () {
        var tip_hand = zAddTipHand(this);
        Global_DP_DiningRoom_ChooseInterface.tip_hand = tip_hand;
    }
});