var Global_DP_DiningRoom = {
    dir: 'res/game/dining_room/',
    dir_choose_interface: 'res/game/dining_room/choose_interface/',
    dir_select_list: 'res/game/dining_room/select_list/',
    layer: null,
    coin_box: null,
    make: {
        food: null,
        food_done: false,
        drink: null,
        drink_done: false
    }
};

function init_Global_DP_DiningRoom() {
    var make = {
        food: null,
        food_done: false,
        drink: null,
        drink_done: false
    };
    Global_DP_DiningRoom.make = make;
}

var DP_DiningRoomLayer = cc.Layer.extend({
    ctor: function () {
        this._super();
        this.x = cc.winSize.width / 2;
        this.y = Global_DP.sinkY;
        Global_DP_DiningRoom.layer = this;

        var bg_hd = zNewSpriteCreate(Global_DP_DiningRoom.dir, 'bg_hd', this);
        bg_hd.setAnchorPoint(0.5, 0);

        var choose_interface = new DP_DiningRoomChooseInterfaceLayer();
        this.addChild(choose_interface);

        zAddBackButtonBegin(this);

        Global_DP_DiningRoom.coin_box = zAddCoinBox(this);

        // this.makeCola();
        // this.makeCake();
        // this.makeLemonJuice();
        // this.makeIceCream();
        // this.makeHamburg();
        // this.makeHotDog();

        // this.addEatLayer();
    },
    onEnter: function () {
        this._super();
        showAdBanner(false, 0.3, 0);
    },
    onExit: function () {
        this._super();
        init_Global_DP_DiningRoom();
        showAdBanner(true, 0.3, 0);
    },
    makeCola: function () {
        var make_cola = new DP_DiningRoom_MakeColaLayer();
        this.addChild(make_cola);
    },
    makeCake: function () {
        var make_cake = new DP_DiningRoom_MakeCakeLayer();
        this.addChild(make_cake);
    },
    makeLemonJuice: function () {
        var make_lemon_juice = new DP_DiningRoom_MakeLemonJuiceLayer();
        this.addChild(make_lemon_juice);
    },
    makeIceCream: function () {
        var make_ice_cream = new DP_DiningRoom_MakeIceCreamLayer();
        this.addChild(make_ice_cream);
    },
    makeHamburg: function () {
        var hamburg = new DP_DiningRoom_MakeHamburgLayer();
        this.addChild(hamburg);
    },
    makeHotDog: function () {
        var hot_dog = new DP_DiningRoom_MakeHotDogLayer();
        this.addChild(hot_dog);
    },
    addEatLayer: function (eat_done_callBack) {
        var make = Global_DP_DiningRoom.make;
        // zLog('food:', make.food);
        // zLog('drink:', make.drink);
        var eat_layer = new DP_DiningRoom_EatLayer(make.food ? make.food : 'food_hamburg', make.drink ? make.drink : 'drink_cola', eat_done_callBack);
        this.addChild(eat_layer);
    }
});

var DP_DiningRoomScene = cc.Scene.extend({
    ctor: function () {
        this._super();

        var layer = new DP_DiningRoomLayer();
        this.addChild(layer);

        zAddKeyboardBackEventCreate(this);
    }
});

function DP_DiningRoomMake() {
    var layer = Global_DP_DiningRoom.layer;
    layer.scheduleOnce(function () {
        var layer = Global_DP_DiningRoom.layer;
        var make = Global_DP_DiningRoom.make;
        if (make.food && !make.food_done) {
            if (make.food.indexOf('cake') >= 0) {
                layer.makeCake();
            } else if (make.food.indexOf('hamburg') >= 0) {
                layer.makeHamburg();
            } else if (make.food.indexOf('hot_dog') >= 0) {
                layer.makeHotDog();
            }
            make.food_done = true;
        } else if (make.drink && !make.drink_done) {
            if (make.drink.indexOf('cola') >= 0) {
                layer.makeCola();
            } else if (make.drink.indexOf('ice_cream') >= 0) {
                layer.makeIceCream();
            } else if (make.drink.indexOf('lemon') >= 0) {
                layer.makeLemonJuice();
            }
            make.drink_done = true;
        } else {
            // zLog('all make finish');
            umengEvent('GAME_SRC_DONE', 'dining_room');
            layer.addEatLayer(() => {
                cc.director.popScene();
            });
        }
    }, 0.1);
}
