var Global_DP_DiningRoom_MakeCake = {
    dir: Global_DP_DiningRoom.dir + 'make_cake/',
    layer: null,
    select_list: null,
    btn_ok: null,
    cake: null,
    done: false,
    tray: null,
    types: [0, 0],
    tip_hand: null
};

function init_Global_DP_DiningRoom_MakeCake() {
    Global_DP_DiningRoom_MakeCake.done = false;
    Global_DP_DiningRoom_MakeCake.types = [0, 0];
}

var DP_DiningRoomMakeCake_Cake = cc.Node.extend({
    ctor: function () {
        this._super();

        this.base = cc.Sprite();
        this.fruit = cc.Sprite();
        this.addChild(this.base);
        this.base.addChild(this.fruit);
        this.setAnchorPoint(0.5, 0.5);
    },
    setBaseImage: function (dir, name) {
        zSetSpriteTexture(dir, name, this.base);
        this.setContentSize(this.base.getContentSize());
        this.base.setPosition(this.width / 2, this.height / 2);
        this.base.setScale(0.3);
        this.base.runAction(cc.scaleTo(0.3, 1));
    },
    setFruitImage: function (dir, name, pos) {
        zSetSpriteTexture(dir, name, this.fruit);
        this.fruit.setPosition(pos);
        // zAddTouchLogPosEvent(this.fruit);
    },
    addEvent: function () {
        var listener = zNewEventListenerCreate(function (touch, target) {
            var tip_hand = Global_DP_DiningRoom_MakeCake.tip_hand;
            tip_hand.stopTipAction();
        }, function (touch, target) {
            var delta = touch.getDelta();
            target.x += delta.x;
            target.y += delta.y;
        }, function (touch, target) {
            var tray = Global_DP_DiningRoom_MakeCake.tray;
            var endPos = cc.pAdd(tray.baseImage.getPosition(), cc.p(tray.baseImage.width / 4, tray.baseImage.height / 4));
            // if (cc.pDistance(target.getPosition(), endPos) < 200) {
            zPauseTargetEvent(target, true);
            ddSound.playEffect('game_all_fly');
            target.runAction(cc.sequence(
                cc.spawn(cc.scaleTo(0.5, 0.35), zGetBezierTo(0.5, target.getPosition(), endPos)).easing(cc.easeOut(2)),
                cc.callFunc(function () {
                    zChangeParent(target, tray.baseImage);
                    target.setPosition(cc.p(tray.baseImage.width * 3 / 4, tray.baseImage.height * 2 / 3));
                })
            ));
            target.scheduleOnce(function () {
                tray.out();
                var layer = Global_DP_DiningRoom_MakeCake.layer;
                layer.scheduleOnce(function () {
                    DP_DiningRoomMake();
                    layer.removeFromParent(true);
                }, 1);
            }, 0.5 + 0.2);
            // }
            // zLogPos(target.getPosition());
        }, null);
        zSetNodeEvent(listener, this);
    }
});

var DP_DiningRoom_MakeCakeLayer = cc.Layer.extend({
    ctor: function () {
        this._super();
        Global_DP_DiningRoom_MakeCake.layer = this;

        this.addSelectList();
        this.addButtonOk();
        this.addCake();
        this.addTray();
        this.addTipHand();
    },
    onEnter: function () {
        this._super();
        // ddSound.stopAll();
        // ddSound.playEffect('select_choose_cake_base');
    },
    onExit: function () {
        this._super();
        // init_Global_DP_DiningRoom_MakeCake();
    },
    addSelectList: function () {
        var dir = Global_DP_DiningRoom.dir;
        var dir_cake = Global_DP_DiningRoom_MakeCake.dir;
        var name_base = ['cheese', 'chiffon', 'chocolate'];
        var name_fruit = ['blueberry', 'cherry', 'lemon'];
        var listener = zNewEventListenerCreate(function (touch, target) {
            // zLog('item idx : ', target.idx);
            // zLog('item name : ', target.getName());
            target.setLocalZOrder(1);
            select_list.pauseOtherItemEvent(target.idx);
            select_list.stopTip();
            ddSound.stopAll();
            if (target.getName().indexOf('base') >= 0) {
                ddSound.playEffect('select_list_cake_base_' + name_base[target.idx])
            } else if (target.getName().indexOf('fruit') >= 0) {
                ddSound.playEffect('select_list_cake_fruit_' + name_fruit[target.idx]);
            }
        }, function (touch, target) {
            var delta = touch.getDelta();
            target.x += delta.x;
            target.y += delta.y;
        }, function (touch, target) {
            // zLog('length : ', select_list.items.length);
            // select_list.setItemBackPos(target.idx);
            var cake = Global_DP_DiningRoom_MakeCake.cake;
            var btn_ok = Global_DP_DiningRoom_MakeCake.btn_ok;
            var worldPos = zGetWorldPosition(cake);
            if (target.getName().indexOf('base') >= 0) {
                var argus = {a: dir_cake, b: target.getName()};
                select_list.moveItemBezierTo(target.idx, worldPos, cake.setBaseImage, cake, argus, true);
                Global_DP_DiningRoom_MakeCake.types[0] = target.idx;
                // cake.setBaseImage(dir_cake, target.getName());
                // cake.setPosition(0, cc.winSize.height / 2);
                // zShowContentSize(cake, cake.getContentSize());
            } else if (target.getName().indexOf('fruit') >= 0) {
                var argus = {a: dir_cake, b: target.getName(), c: cc.p(297.03, 364.63)};
                select_list.moveItemBezierTo(target.idx, cc.pAdd(worldPos, cc.p(50, 140)), cake.setFruitImage, cake, argus, true);
                // cake.setFruitImage(dir_cake, target.getName());
                Global_DP_DiningRoom_MakeCake.types[1] = target.idx;
                Global_DP_DiningRoom_MakeCake.done = true;
            }
            btn_ok.into();
        }, null);
        var select_list = zAddSelectList(this,
            {name: 'side_column', zOrder: 10},
            {
                from: cc.p(cc.winSize.width / 2 + 200, 451.40),
                to: cc.p(542.16 + (isFullScreenDevice() ? 60 : 0), 451.40),
                time: 0.5
            },
            {name: 'side_column_box'},
            {dir: dir_cake, name: ['cake_base_0', 'cake_base_1', 'cake_base_2']},
            listener
        );
        select_list.into();
        // select_list.hide();
        // select_list.pauseEvent();

        Global_DP_DiningRoom_MakeCake.select_list = select_list;
    },
    addButtonOk: function () {
        var self = this;
        var dir_cake = Global_DP_DiningRoom_MakeCake.dir;
        var btn_ok = zAddDiningRoomButtonOK(self);
        btn_ok.setEventCallBack(function () {
            var select_list = Global_DP_DiningRoom_MakeCake.select_list;
            select_list.out();
            btn_ok.out();
            self.scheduleOnce(function () {
                if (!Global_DP_DiningRoom_MakeCake.done) {
                    select_list.setItem(dir_cake, 'cake_fruit_0', 0);
                    select_list.setItem(dir_cake, 'cake_fruit_1', 1);
                    select_list.setItem(dir_cake, 'cake_fruit_2', 2);
                    select_list.into();
                } else {
                    var tray = Global_DP_DiningRoom_MakeCake.tray;
                    var cake = Global_DP_DiningRoom_MakeCake.cake;
                    tray.into();
                    cake.scheduleOnce(function () {
                        cake.addEvent();
                        zAddParticleDone(self);
                        ddSound.stopAll();
                        ddSound.playEffect('game_dinning_room_put_cake_on_tray');
                        var tip_hand = Global_DP_DiningRoom_MakeCake.tip_hand;
                        tip_hand.autoTipAction(cake.getPosition());
                    }, 0.5);
                }
            }, 1);
        }, this);
        Global_DP_DiningRoom_MakeCake.btn_ok = btn_ok;
    },
    addCake: function () {
        var cake = new DP_DiningRoomMakeCake_Cake();
        cake.setPosition(0, 750 / 2);
        this.addChild(cake, 5);
        Global_DP_DiningRoom_MakeCake.cake = cake;
    },
    addTray: function () {
        Global_DP_DiningRoom_MakeCake.tray = zAddDiningRoomTray(this);
    },
    addTipHand: function () {
        var tip_hand = zAddTipHand(this);
        Global_DP_DiningRoom_MakeCake.tip_hand = tip_hand;
    }
});