var Global_DP_DiningRoom_MakeLemonJuice = {
    dir: Global_DP_DiningRoom.dir + 'make_lemon_juice/',
    layer: null,
    select_list: null,
    btn_ok: null,
    tray: null,
    machine: null,
    cup: null,
    cup_step: null,
    straw_type: 0,
    tip_hand: null,
    tip_arrow_curve: null
};

function init_Global_DP_DiningRoom_MakeLemonJuice() {
    Global_DP_DiningRoom_MakeLemonJuice.cup_step = null;
    Global_DP_DiningRoom_MakeLemonJuice.straw_type = 0;
}

var DP_DiningRoom_MakeLemonJuice_Cup = cc.Node.extend({
    ctor: function () {
        this._super();
        Global_DP_DiningRoom_MakeLemonJuice.cup = this;
        Global_DP_DiningRoom_MakeLemonJuice.cup_step = 'pour';

        var dir = Global_DP_DiningRoom_MakeLemonJuice.dir;
        var cup_front = zNewSpriteCreate(dir, 'cup_front', this);
        var cup_behind = zNewSpriteCreate(dir, 'cup_behind', this);
        cup_front.setLocalZOrder(2);
        cup_behind.setPosition(140.96, 399.77);

        var lemon_juice = zNewSpineAnimationCreate(Global_DP_DiningRoom.dir + 'spine/', 'skeleton', this);
        // lemon_juice.setAnimation(0, 'daoningmeng', true);
        lemon_juice.setTimeScale(0.5);
        lemon_juice.setScale(1.85);
        lemon_juice.setPosition(142.00, 249.04);
        lemon_juice.setLocalZOrder(1);

        this.lemon_juice = lemon_juice;

        this.setContentSize(cup_front.getContentSize());
        cup_front.setPosition(cup_front.width / 2, cup_front.height / 2);
        // zAddTouchLogPosEvent(cup_behind);
        // zAddTouchLogPosEvent(lemon_juice_front);
        // zAddTouchLogPosEvent(lemon_juice_behind);
    },
    setCupEvent: function () {
        var listener = zNewEventListenerCreate(function (touch, target) {
            var tip_hand = Global_DP_DiningRoom_MakeLemonJuice.tip_hand;
            tip_hand.stopTipAction();
        }, function (touch, target) {
            var delta = touch.getDelta();
            target.x += delta.x;
            target.y += delta.y;
        }, function (touch, target) {
            // zLogPos(target.getPosition());
            zPauseTargetEvent(target, true);
            var step = Global_DP_DiningRoom_MakeLemonJuice.cup_step;
            if (step == 'pour') {
                target.runAction(cc.sequence(
                    zGetBezierTo(0.5, target.getPosition(), cc.p(-73.41, 198.52)).easing(cc.easeIn(2)),
                    cc.callFunc(() => {
                        var machine = Global_DP_DiningRoom_MakeLemonJuice.machine;
                        var tip_arrow_curve = Global_DP_DiningRoom_MakeLemonJuice.tip_arrow_curve;
                        var layer = Global_DP_DiningRoom_MakeLemonJuice.layer;
                        machine.setHandleEvent();
                        ddSound.stopAll();
                        ddSound.playEffect('turn_on_the_handle');
                        var np = layer.convertToNodeSpace(zGetWorldPosition(machine.machine_handle));
                        tip_arrow_curve.autoTipAction(np);
                    })
                ));
                Global_DP_DiningRoom_MakeLemonJuice.cup_step = 'put';
            } else if (step == 'put') {
                var tray = Global_DP_DiningRoom_MakeLemonJuice.tray;
                var tray_pos = tray.baseImage.getPosition();
                var node_pos = cc.p(tray.baseImage.width * (3 - 2.5) / 5, tray.baseImage.height * (1 - 1.5) / 3);
                var end_pos = cc.pAdd(tray_pos, node_pos);
                ddSound.playEffect('game_all_fly');
                target.runAction(cc.sequence(
                    zGetBezierTo(0.5, target.getPosition(), end_pos).easing(cc.easeOut(2)),
                    cc.callFunc(() => {
                        zChangeParent(target, tray.baseImage);
                        target.setPosition(tray.baseImage.width * 3 / 5, tray.baseImage.height / 3);
                    }),
                    cc.delayTime(0.5),
                    cc.callFunc(() => {
                        tray.out();
                    })
                ));
                var layer = Global_DP_DiningRoom_MakeLemonJuice.layer;
                layer.scheduleOnce(function () {
                    DP_DiningRoomMake();
                    layer.removeFromParent(true);
                }, 1.5);
            }
        }, null);
        zSetNodeEvent(listener, this);
        // zShowContentSize(this, this.getContentSize());
    },
    addStraw: function (name) {
        switch (name) {
            case 'straw_0':
                this.lemon_juice.setAnimation(0, 'ningmeng' + 'fen', false);
                break;
            case 'straw_1':
                this.lemon_juice.setAnimation(0, 'ningmeng' + 'lv', false);
                break;
            case 'straw_2':
                this.lemon_juice.setAnimation(0, 'ningmeng' + 'huang', false);
                break;
        }
    }
});

var DP_DiningRoom_MakeLemonJuice_Machine = cc.Node.extend({
    state: 'waiting',
    ctor: function () {
        this._super();
        Global_DP_DiningRoom_MakeLemonJuice.machine = this;

        var dir_lemon = Global_DP_DiningRoom_MakeLemonJuice.dir;
        var machine_body = zNewSpriteCreate(dir_lemon, 'machine_body', this);
        var machine_handle = zNewSpriteCreate(dir_lemon, 'machine_handle', machine_body);
        var machine_input = zNewSpriteCreate(dir_lemon, 'machine_input', machine_body);

        machine_handle.setAnchorPoint(14 / machine_handle.width, 17 / machine_handle.height);
        machine_handle.setPosition(446.98, 454.98);
        machine_handle.setLocalZOrder(-1);
        machine_input.setPosition(222.11, 315.58);

        this.machine_handle = machine_handle;
        this.machine_input = machine_input;

        // zAddTouchLogPosEvent(machine_handle);
        // zAddTouchLogPosEvent(machine_input);
        // zAddTouchLogPosEvent(lemon_flow);
    },
    setHandleEvent: function () {
        var listener = zNewEventListenerCreate(null, function (touch, target) {
            var delta = touch.getDelta();
            if (delta.y < 0) {
                var tip_arrow_curve = Global_DP_DiningRoom_MakeLemonJuice.tip_arrow_curve;
                tip_arrow_curve.stopTipAction();
                zPauseTargetEvent(target, true);
                ddSound.playEffect('turn_handle');
                target.runAction(cc.sequence(
                    cc.rotateTo(0.2, 45),
                    cc.callFunc(() => {
                        var machine = Global_DP_DiningRoom_MakeLemonJuice.machine;
                        var cup = Global_DP_DiningRoom_MakeLemonJuice.cup;
                        var select_list = Global_DP_DiningRoom_MakeLemonJuice.select_list;
                        machine.machine_input.setGlobalZOrder(1);
                        ddSound.playEffect('game_dinning_pour_drink');
                        cup.lemon_juice.setAnimation(0, 'daoningmeng', false);
                        cup.lemon_juice.setCompleteListener((trackEntry) => {
                            var name = trackEntry.animation ? trackEntry.animation.name : '';
                            if (name == 'daoningmeng') {
                                machine.setVisible(false);
                                select_list.show();
                                select_list.into();
                                ddSound.stopAll();
                                ddSound.playEffect('select_choose_straw');
                            }
                        });
                    })
                ));

            }
        }, null, null);
        zSetNodeEvent(listener, this.machine_handle);
    }
});

var DP_DiningRoom_MakeLemonJuiceLayer = cc.Layer.extend({
    ctor: function () {
        this._super();
        Global_DP_DiningRoom_MakeLemonJuice.layer = this;

        var machine = new DP_DiningRoom_MakeLemonJuice_Machine();
        machine.setPosition(0, 435.79);
        this.addChild(machine);

        // zAddTouchLogPosEvent(cup);

        this.addCup();
        this.addSelectList();
        this.addButtonOk();
        this.addTray();
        this.addTip();

    },
    onEnter: function () {
        this._super();

        var cup = Global_DP_DiningRoom_MakeLemonJuice.cup;
        var tip_hand = Global_DP_DiningRoom_MakeLemonJuice.tip_hand;
        tip_hand.autoTipAction(cc.pAdd(cup.getPosition(), cc.p(100, 100)));
    },
    onExit: function () {
        this._super();
        // init_Global_DP_DiningRoom_MakeLemonJuice();
    },
    addSelectList: function () {
        var name_straw = ['purple', 'green', 'yellow'];
        var listener = zNewEventListenerCreate(function (touch, target) {
            target.setLocalZOrder(1);
            select_list.pauseOtherItemEvent(target.idx);
            select_list.stopTip();
            ddSound.stopAll();
            ddSound.playEffect('select_list_straw_' + name_straw[target.idx]);
        }, function (touch, target) {
            var delta = touch.getDelta();
            target.x += delta.x;
            target.y += delta.y;
        }, function (touch, target) {
            // zLog('length : ', select_list.items.length);
            // select_list.setItemBackPos(target.idx);
            var cup = Global_DP_DiningRoom_MakeLemonJuice.cup;
            var btn_ok = Global_DP_DiningRoom_MakeLemonJuice.btn_ok;
            var world_pos = cc.pAdd(zGetWorldPosition(cup), cc.p(cup.width / 2, cup.height / 2));
            var argus = {a: target.getName()};
            select_list.moveItemBezierTo(target.idx, world_pos, cup.addStraw, cup, argus, true);
            Global_DP_DiningRoom_MakeLemonJuice.straw_type = target.idx;
            // cup.addStraw(Global_DP_DiningRoom.dir_select_list, target.getName());
            btn_ok.into();
        }, null);
        var select_list = zAddSelectList(this,
            {name: 'side_column', zOrder: 10},
            {from: cc.p(cc.winSize.width / 2 + 200, 451.40), to: cc.p(cc.winSize.width / 2 - 120, 451.40), time: 0.5},
            {name: 'side_column_box'},
            {dir: Global_DP_DiningRoom.dir_select_list, name: ['straw_0', 'straw_1', 'straw_2']},
            listener
        );
        // select_list.into();
        Global_DP_DiningRoom_MakeLemonJuice.select_list = select_list;
    },
    addCup: function () {
        var cup = new DP_DiningRoom_MakeLemonJuice_Cup();
        cup.setScale(0.5);
        cup.setPosition(222.69, 147.85);
        cup.setCupEvent();
        cup.setLocalZOrder(5);
        this.addChild(cup);
    },
    addTray: function () {
        Global_DP_DiningRoom_MakeLemonJuice.tray = zAddDiningRoomTray(this);

    },
    addButtonOk: function () {
        var self = this;
        var btn_ok = zAddDiningRoomButtonOK(self);
        btn_ok.setEventCallBack(function () {
            var select_list = Global_DP_DiningRoom_MakeLemonJuice.select_list;
            var cup = Global_DP_DiningRoom_MakeLemonJuice.cup;
            var tray = Global_DP_DiningRoom_MakeLemonJuice.tray;
            select_list.out();
            btn_ok.out();
            self.scheduleOnce(function () {
                tray.into();
                cup.scheduleOnce(function () {
                    zResumeTargetEvent(cup, true);
                    zAddParticleDone(self);
                    ddSound.stopAll();
                    ddSound.playEffect('game_dinning_room_put_juice_on_tray');
                    var tip_hand = Global_DP_DiningRoom_MakeLemonJuice.tip_hand;
                    tip_hand.autoTipAction(cc.pAdd(cup.getPosition(), cc.p(100, 100)));
                }, 0.5);
            }, 1);
        }, this);
        Global_DP_DiningRoom_MakeLemonJuice.btn_ok = btn_ok;
    },
    addTip: function () {
        this.addTipHand();
        this.addTipArrowCurve();
    },
    addTipHand: function () {
        var tip_hand = zAddTipHand(this);
        Global_DP_DiningRoom_MakeLemonJuice.tip_hand = tip_hand;
    },
    addTipArrowCurve: function () {
        var tip_arrow_curve = zAddTipArrowCurve(this);
        Global_DP_DiningRoom_MakeLemonJuice.tip_arrow_curve = tip_arrow_curve;
    }
});